package fr.iut.pm.movieapplication.data.dao

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import fr.iut.pm.movieapplication.model.Movie
import kotlinx.coroutines.flow.Flow

@Dao
interface MovieDAO {

    @Query("SELECT * FROM movies_table ORDER BY original_title ASC")
    fun getMovieByAlphabetizeMovie() : Flow<List<Movie>>

    @Insert(onConflict = OnConflictStrategy.IGNORE)
    suspend fun insert(movie : Movie)

    @Query("DELETE FROM movies_table")
    suspend fun deleteAll()


}