package fr.iut.pm.movieapplication.ui.adapter

import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.core.net.toUri
import androidx.recyclerview.widget.RecyclerView
import coil.load
import fr.iut.pm.movieapplication.R
import fr.iut.pm.movieapplication.api.config.GlobalImageConfig
import fr.iut.pm.movieapplication.model.Movie
import fr.iut.pm.movieapplication.ui.activity.MainActivity
import fr.iut.pm.movieapplication.utils.Constants.Companion.IMG_URL

class HomeItemAdapter(
    private val context: MainActivity,
    private val layoutId: Int,
    private val list: List<Movie>
    ) : RecyclerView.Adapter<HomeItemAdapter.ViewHolder>() {

    class ViewHolder(view : View) : RecyclerView.ViewHolder(view) {
        val itemImage: ImageView = view.findViewById<ImageView>(R.id.item_image)
        val itemName: TextView = view.findViewById<TextView>(R.id.item_name)
        val itemDate: TextView = view.findViewById<TextView>(R.id.item_date)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater
            .from(parent.context)
            .inflate(layoutId, parent, false)
        return ViewHolder(view)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val currentItem = list[position]
        Log.d("SINGLETON", GlobalImageConfig.baseUrl)
        val imgUri = currentItem.posterPath?.let {
            (IMG_URL + it).toUri().buildUpon().scheme("https").build()

        }
        Log.d("SINGLETON", imgUri.toString() )
        holder.itemImage.load(imgUri)
        holder.itemName.text = currentItem.title
        holder.itemDate.text = currentItem.releaseDate

    }

    override fun getItemCount(): Int = list.size
}