package fr.iut.pm.movieapplication.ui.viewmodel

import androidx.lifecycle.*
import fr.iut.pm.movieapplication.api.dtos.MovieResultDTO
import fr.iut.pm.movieapplication.model.Movie
import fr.iut.pm.movieapplication.repository.MovieRepository
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.launch

class MoviesVM(private val repository: MovieRepository) : ViewModel() {

    private val _popularMovies = MutableLiveData<List<Movie>>()
    val popularMovies : LiveData<List<Movie>> = _popularMovies

    init {
        //loadData()
    }
    suspend fun loadData()  {
        viewModelScope.launch {
            repository.getPopularMovies { movies ->
                _popularMovies.value = movies
            }
        }.join()

    }
}



class MoviesVMFactory(
    private val repository: MovieRepository
    ) : ViewModelProvider.Factory {
    override fun <T : ViewModel> create(modelClass: Class<T>): T {
        return MoviesVM(repository) as T
    }

}